# -*- coding: utf-8 -*-
"""
splitRaster.py

@author: elias adediran

Oct 7 2022

brought to pycharm from spyder Mar 24 2023

"""
import matplotlib as mpl
# mpl.use('TkAgg')
mpl.use('Qt5Agg')
import os
import os.path
import glob
import sys
from osgeo import gdal, ogr
import numpy as np
import random
# np.set_printoptions(precision=2, floatmode='fixed')
import matplotlib.pyplot as plt
from mpl_toolkits import mplot3d
# plt.style.use('./deeplearning.mplstyle')
from scipy.interpolate import griddata #UnivariateSpline, SmoothBivariateSpline
from scipy import signal, stats
import pandas as pd
import matplotlib.ticker as ticker
import seaborn as sns
# import pykrige.kriging_tools as kt
# from pykrige.ok import OrdinaryKriging
from scipy.stats import spearmanr
import statsmodels.api as sm
import statsmodels.formula.api as smf
from matplotlib_scalebar.scalebar import ScaleBar
# mpl.rcParams['agg.path.chunksize'] = 10000
from datetime import datetime
# MLlibraries
from sklearn.linear_model import SGDRegressor, LinearRegression
from sklearn.preprocessing import StandardScaler, MinMaxScaler
from sklearn.model_selection import train_test_split
from sklearn import metrics
from sklearn.linear_model import LinearRegression
from sklearn.neural_network import MLPRegressor
from sklearn.ensemble import RandomForestRegressor
# Keras
from keras.models import Sequential
from keras.layers import Dense
import shap
#Stats
from statsmodels.stats.multicomp import pairwise_tukeyhsd
import scipy.stats as stats
from scipy.stats import kruskal
import scikit_posthocs as sp

# import my own functions
from Slope_Roughness import cal_slope, cal_roughness
from Remove_ndv_on_edges import Remove_edge
from IDW_Interpolation import idw_interpolation
from sample_raster_by_percent import sample_raster_by_percent
from compute_proximity_distance import compute_proximity_distance
from calculate_cell_number import calculate_cell_number
from separate_data import separate_data
from extract_pixel_coordinates import extract_pixel_coordinates
from myslopecal import calculate_slope_horn
from myroughnesscal import calculate_raster_roughness
from find_percentile import find_percentile

# gdal.UseExceptions()  # this allows GDAL to throw Python Exceptions
# plt.style.use('seaborn')
# plt.style.use('default')
# plt.rcParams.update(plt.rcParamsDefault) #Restore Matplotlib Default Font Sizes

# format plotting
# Plotting parameters
# parameters = {'axes.labelsize': 12,
#               'axes.titlesize': 12,
#               'xtick.labelsize': 12,
#               'ytick.labelsize': 12}
# plt.rcParams.update(parameters)

# plt.rc("figure", figsize=(16, 8))
# plt.rc("font", size=14)

# from osgeo_utils import gdalcompare

# os.chdir(r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\GDAL")
# os.chdir(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\GDAL")
# print(os.getcwd())
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\GDAL\NH_Clip.tif" #inset
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\GDAL\NH_Clip_1km.tif"
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Coverage and Uncertainty_From Glen\Data\BlueTopo_US5NH1AH_20220505.tiff"
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\Alaska\kachemak_10m.tif"
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\Alaska\H11934_MB_VR_MLLW_1of2.bag"
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Data_Exploration\Alaska\kachemak_clip_4mto10m.tif"
# file_path = r"C:\Users\Elias Adediran\PycharmProjects\Thesis_Random_Samping\kachemak_clip_4mto10m_updated.tif"
# file_path = r"C:\Users\Elias Adediran\OneDrive - USNH\Documents\Thesis\Datasets\Flat\Flat_LA_8m_NAVD88_10km_Updated.tif"
# file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Final_Datasets\SS_Rough_Slopey_ME_4m_NAVD88_5km.tif"
# file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Final_Datasets\SS_Rough_Slopey_ME_8m_NAVD88_5km.tif"
# file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Final_Datasets\SS_Rough_Slopey_ME_16m_NAVD88_5km.tif"
# file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Rough_Slopey\Rough_Slopey_ME_8m_NAVD88_10km.tif"
file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Final_Datasets\Flat_LA_8m_NAVD88_10km_Updated.tif"
# file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Final_Datasets\Rough_FL_8m_NAVD88_10km.tif"
# file_path = r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Datasets\Final_Datasets\Slopey_MA_8m_NAVD88_10km.tif"


# outdir is where the results will go.
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Spatial_scale/Random/Rough_Slopey/1%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Spatial_scale/Random/Rough_Slopey/8m resolution/1%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Spatial_scale/Random/Rough_Slopey/16m resolution/1%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Spatial_scale/Random/Rough_Slopey/Resolution/16m resolution/50%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Spatial_scale/Random/Rough_Slopey/Window_size/7by7/50%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Spatial_scale/Random/Rough_Slopey/Window_size/5by5/50%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Figures/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Report/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Flat/1%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Rough/1%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Slopey/50%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Rough_Slopey/25%/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Comp/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Comp/Check/"
# outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Report/"
outdir = "C:/Users/eadediran/OneDrive - USNH/Documents/Thesis/Results/Random/Stats/Pairwise/"
##########################################
print('Start time:',datetime.now())

# import the file and get all the necessary info
ds = gdal.Open(file_path)
if not ds:
    raise RuntimeError("Issue in opening the file: %s" % file_path)

print("File was successfully opened: %s" % (file_path,))

depth_gt = ds.GetGeoTransform()
proj = ds.GetProjection()
depth_band = ds.GetRasterBand(1)
ndv = depth_band.GetNoDataValue()
depth_raw = depth_band.ReadAsArray()
res = depth_gt[1]
x_res = depth_gt[1]
y_res = depth_gt[5]
xsize = ds.RasterXSize
ysize = ds.RasterYSize
ds = None

#######################################Define the parameters#######################################
# location
location = 'LA'
# location = 'FL'
# location = 'ME'
# location = 'MA'
# location = 'AL'

# seabed type
seabed = 'Flat'
# seabed = 'Rough'
# seabed = 'Rough and Slopey'
# seabed = 'Slopey'
# seabed = 'mixed'

# percent of data
# percent = np.array([1,5,10,25,50])
percent = 50

# number of iterations
no_of_iter = 10

# Remove edges with ndv
depth = Remove_edge(data=depth_raw, ndv=ndv)

# Get the data extent
ulx = depth_gt[0]
uly = depth_gt[3]
lrx = depth_gt[0] + depth.shape[1] * depth_gt[1]
lry = depth_gt[3] + depth.shape[0] * depth_gt[5]

# Replace ndv that are nans and inf with -9999
if ndv == -1.7976931348623157e+308 or 1.7976931348623157e+308:
    ndv = -9999
else:
    ndv = np.nan_to_num(ndv, copy=False, nan=-9999, posinf=-9999, neginf=-9999)

# Calculate the number of cells to be removed from the border
# cell_number = calculate_cell_number(array=depth, no_of_iter=no_of_iter, ndv=ndv, sampling_percent=1, plot=True)
cell_number = 12

# # Separate the data into inbound and outbound
# It returns the inbound i.e. data to be sampled for interpolation and outbound i.e. data with boundary to avoid the edge effect

# Specify the window size
window_size = 3  # 3, 5 or 7  window size by window size

if window_size == 3:
    pixel = 1 # number of pixels to be remained on the boundary for edge effect
    additive_constant = 1
elif window_size == 5:
    pixel = 2
    additive_constant = 2
elif window_size == 7:
    pixel = 3
    additive_constant = 3
else:
    raise ValueError('Window size specified is invalid, please enter 3, 5 or 7')

# Extract inbound data
depth_inbound, depth_outbound = separate_data(depth, number=cell_number, pixel=pixel, ndv=ndv)


# sample the data by percent
# train_sample, test_sample = random_sample(depth, percent)
# train_sample, test_sample = sample_raster_by_percent(depth, 50, ndv=ndv)

# # Create the train and test samples 200 times for each sampling density

train_data = np.empty(no_of_iter, dtype=object)
test_data = np.empty(no_of_iter, dtype=object)
for j in range(no_of_iter):
    train_data[j], test_data[j] = sample_raster_by_percent(depth_inbound, percent, ndv=ndv)

# count the number of counts for the ndv to be sure the random sampling is well fine
# count_list = []
# for i in range(no_of_iter):
#     count_list.append(np.count_nonzero(train_data[i] == ndv))

# this function combines the inbound with the boundary data in order to eliminate edge effects
def Combine(inbound, outbound, number, constant):
    result = outbound.copy()
    result[number + constant:result.shape[0] - (number + constant), number + constant:result.shape[1] - (number + constant)] = inbound
    return result


train_bound = np.empty(no_of_iter, dtype=object)
test_bound = np.empty(no_of_iter, dtype=object)
for i in range(no_of_iter):
    train_bound[i] = Combine(train_data[i], depth_outbound, cell_number, additive_constant)
    test_bound[i] = Combine(test_data[i], depth_outbound, cell_number, additive_constant)


# A function that converts array to dataframe and removes the no data value. It returns df
# The df values are used for the Scipy interpolation.
df_coordinates = extract_pixel_coordinates(file_path)
x_coordinates_bound = df_coordinates.easting.values.reshape(depth.shape[0],depth.shape[1])[cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)].flatten().reshape(-1,1)
y_coordinates_bound = df_coordinates.northing.values.reshape(depth.shape[0],depth.shape[1])[cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)].flatten().reshape(-1,1)
xy_coordinates = np.hstack((df_coordinates.easting.values.reshape(-1,1),df_coordinates.northing.values.reshape(-1,1)))
xy_coordinates_bound = np.hstack((x_coordinates_bound,y_coordinates_bound)) # used for plotting scatter

df_train = np.empty(no_of_iter, dtype=object)

for j in range(no_of_iter):
    df_train[j] = np.hstack((df_coordinates,train_bound[j].flatten().reshape(-1,1)))
    df_train[j] = pd.DataFrame(df_train[j], columns=['x', 'y', 'z'])
    df_train[j] = df_train[j][df_train[j] != ndv].dropna().reset_index(drop=True)

df_complete = pd.DataFrame(np.hstack((df_coordinates,depth.flatten().reshape(-1,1))),columns=['x', 'y', 'z'])

# This function converts array to tif. I am leaving it as part of the code because it gets some of its parameters from the original file
# You need to convert the array to tif in order to obtain the xyz coordinate of the points to interpolate because you need this for Scipy to work.
def array_to_tif(array, output_filename):
    driver = gdal.GetDriverByName("GTiff")
    outds = driver.Create(output_filename, xsize=array.shape[1],
                          ysize=array.shape[0], bands=1,
                          eType=gdal.GDT_Float32)
    outds.SetGeoTransform(depth_gt)
    outds.SetProjection(proj)
    outband = outds.GetRasterBand(1)
    outband.WriteArray(array)
    outband.SetNoDataValue(ndv)
    outband.FlushCache()
    return output_filename
    outds = outband = None

# # export the selected lines to Geotiff
train_bound_tif = np.empty(no_of_iter, dtype=object)
for i in range(no_of_iter):
    train_bound_tif[i] = array_to_tif(train_bound[i],
                                      outdir + location + '_train_bound_' + str(percent) +'%_'+ str(i+1) +'.tif')
#
original_file_tif = array_to_tif(depth, outdir + location + '_original_file.tif')  # export the original file

# Prepare data for interpolation in Scipy
x = np.empty(no_of_iter, dtype=object)
y = np.empty(no_of_iter, dtype=object)
z = np.empty(no_of_iter, dtype=object)
for i in range(no_of_iter):
    x[i] = df_train[i].x
    y[i] = df_train[i].y
    z[i] = df_train[i].z

grid_x = df_complete.x.to_numpy().reshape(depth.shape[0], depth.shape[1])
grid_y = df_complete.y.to_numpy().reshape(depth.shape[0], depth.shape[1])
grid_idw = list(zip(df_complete.x,df_complete.y))  # IDW implementation needs a zip of x and y

# Interpolation
lin_interp = np.empty(no_of_iter, dtype=object)
spline_interp = np.empty(no_of_iter, dtype=object)
idw_interp = np.empty(no_of_iter, dtype=object)

for i in range(no_of_iter):
    lin_interp[i] = griddata((x[i], y[i]), z[i], (grid_x, grid_y), method='linear')
    spline_interp[i] = griddata((x[i], y[i]), z[i], (grid_x, grid_y), method='cubic')
    idw_interp[i] = idw_interpolation(x[i], y[i], z[i], grid_idw, k=8, power=2).reshape(depth.shape[0], depth.shape[1])

print('interpolation completed, time:',datetime.now())

# Convert the interpolated arrays to tif so that you can do the slope and roughness calculation on the tiff files.
lin_interp_tif = np.empty(no_of_iter, dtype=object)
spline_interp_tif = np.empty(no_of_iter, dtype=object)
idw_interp_tif = np.empty(no_of_iter, dtype=object)

for i in range(no_of_iter):
    lin_interp_tif[i] = array_to_tif(lin_interp[i], outdir + location + '_' + seabed + '_lin_interp_' + str(
        percent) + '%_' + str(i + 1) + '.tif')

    spline_interp_tif[i] = array_to_tif(spline_interp[i],
                                        outdir + location + '_' + seabed + '_spline_interp_' + str(
        percent) + '%_' + str(i + 1) + '.tif')

    idw_interp_tif[i] = array_to_tif(idw_interp[i],
                                        outdir + location + '_' + seabed + '_idw_interp_' + str(
        percent) + '%_' + str(i + 1) + '.tif')

# replace the ndv in the test bound with np.nan and find the residual
# also get the indexes of the test bound, convert it to boolean so that you can use it to mask the slope and curvature
test_bound_new = np.empty(no_of_iter, dtype=object)
test_inbound_index = np.empty(no_of_iter, dtype=object)
lin_residual = np.empty(no_of_iter, dtype=object)
spline_residual = np.empty(no_of_iter, dtype=object)
idw_residual = np.empty(no_of_iter, dtype=object)


for i in range(no_of_iter):
    test_bound_new[i] = np.where(test_bound[i] == ndv, np.nan, test_bound[i])
    test_inbound_index[i] = np.isnan(test_bound_new[i])[cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                            cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)]
    lin_residual[i] = (test_bound_new[i] - lin_interp[i])[cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                            cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)]
    # lin_residual[i] = (test_bound_new[i] - lin_interp[i])/test_bound_new[i]*100
    spline_residual[i] = (test_bound_new[i] - spline_interp[i])[cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                            cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)]
    idw_residual[i] = (test_bound_new[i] - idw_interp[i])[cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                            cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)]

# %%
# Calculate slope and roughness using the imported function
# After calculating the slope, extract the inbound and make the train sample nan since they won't be used for the residual analysis
lin_slope = np.empty(no_of_iter, dtype=object)
spline_slope = np.empty(no_of_iter, dtype=object)
idw_slope = np.empty(no_of_iter, dtype=object)

for i in range(no_of_iter):
    if window_size == 3:
        lin_slope[i] = cal_slope(lin_interp_tif[i], outdir + location + '_' + seabed + '_lin_slope_' + str(percent) + '%_' + str( i + 1) + '.tif')
        spline_slope[i] = cal_slope(spline_interp_tif[i], outdir + location + '_' + seabed + '_spline_slope_' + str(percent) + '%_' + str(i + 1) + '.tif')
        idw_slope[i] = cal_slope(idw_interp_tif[i], outdir + location + '_' + seabed + '_idw_slope_' + str(percent) + '%_' + str(i + 1) + '.tif')
    elif window_size == 5 or 7:
        lin_slope[i] = calculate_slope_horn(raster_array=lin_interp[i], cell_size=x_res, window_size=window_size)
        spline_slope[i] = calculate_slope_horn(raster_array=spline_interp[i], cell_size=x_res, window_size=window_size)
        idw_slope[i] = calculate_slope_horn(raster_array=idw_interp[i], cell_size=x_res, window_size=window_size)
    lin_slope[i] = np.ma.array(lin_slope[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)],
                               mask=test_inbound_index[i], fill_value=np.nan).filled()
    spline_slope[i] = np.ma.array(spline_slope[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)],
                               mask=test_inbound_index[i], fill_value=np.nan).filled()
    idw_slope[i] = np.ma.array(idw_slope[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)],
                               mask=test_inbound_index[i], fill_value=np.nan).filled()

# Roughness
lin_roughness = np.empty(no_of_iter, dtype=object)
spline_roughness = np.empty(no_of_iter, dtype=object)
idw_roughness = np.empty(no_of_iter, dtype=object)

for i in range(no_of_iter):
    if window_size == 3:
        lin_roughness[i] = cal_roughness(lin_interp_tif[i], outdir + location + '_lin_roughness_' + str(i + 1) + '_' + str(percent) + '%_samp.tif')
        spline_roughness[i] = cal_roughness(spline_interp_tif[i], outdir + location + '_spline_roughness_' + str(i + 1) + '_' + str(percent) + '%_samp.tif')
        idw_roughness[i] = cal_roughness(idw_interp_tif[i], outdir + location + '_idw_roughness_' + str(i + 1) + '_' + str(percent) + '%_samp.tif')
    elif window_size == 5 or 7:
        lin_roughness[i] = calculate_raster_roughness(array=lin_interp[i], window_size=window_size)
        spline_roughness[i] = calculate_raster_roughness(array=spline_interp[i], window_size=window_size)
        idw_roughness[i] = calculate_raster_roughness(array=idw_interp[i], window_size=window_size)
    lin_roughness[i] = np.ma.array(lin_roughness[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)],
                               mask=test_inbound_index[i], fill_value=np.nan).filled()
    spline_roughness[i] = np.ma.array(spline_roughness[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)],
                               mask=test_inbound_index[i], fill_value=np.nan).filled()
    idw_roughness[i] = np.ma.array(idw_roughness[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                               cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)],
                               mask=test_inbound_index[i], fill_value=np.nan).filled()

# %%
# Calculate distance to nearest measurements or group of points
distance_array = np.empty(no_of_iter, dtype=object)

for i in range(no_of_iter):
    distance_array[i] = compute_proximity_distance(array=train_bound[i], target_value=ndv)
    distance_array[i] = distance_array[i][cell_number + additive_constant:depth_outbound.shape[0] - (cell_number + additive_constant),
                              cell_number + additive_constant:depth_outbound.shape[1] - (cell_number + additive_constant)]
print('Extracted all parameters, time:',datetime.now())

# Calculation of RMSE and MAE
def Cal_Stats(lin_array, idw_array, spline_array, percentile, ndv):
    df_stats = pd.DataFrame()
    for i in range(len(lin_array)):
        df_lin = find_percentile(array=lin_array[i], percentile=percentile, ndv=ndv)
        df_idw = find_percentile(array=idw_array[i], percentile=percentile, ndv=ndv)
        df_spl = find_percentile(array=spline_array[i], percentile=percentile, ndv=ndv)

        # calculate squared difference
        idw_squared_diff = df_idw**2
        lin_squared_diff = df_lin**2
        spl_squared_diff = df_spl**2

        # Calculate the mean squared error
        idw_rmse = np.sqrt(idw_squared_diff.mean())
        lin_rmse = np.sqrt(lin_squared_diff.mean())
        spl_rmse = np.sqrt(spl_squared_diff.mean())
        
        # Calculate the mean absolute error
        idw_mae = np.abs(df_lin).mean()
        lin_mae = np.abs(df_idw).mean()
        spl_mae = np.abs(df_spl).mean()
        
        # combine
        stats = pd.DataFrame(data={
            'IDW_RMSE': [idw_rmse],
            'Linear_RMSE': [lin_rmse],
            'Spline_RMSE': [spl_rmse],
            'IDW_MAE': [idw_mae],
            'Linear_MAE': [lin_mae],
            'Spline_MAE': [spl_mae],
            'density': [percent],
            'i': [i+1]
        })
        df_stats = pd.concat([df_stats, stats], ignore_index=True)

    median_row = df_stats.median().to_frame().transpose()
    mean_row = df_stats.mean().to_frame().transpose()
    df_stats = df_stats.append(median_row, ignore_index=True)
    df_stats = df_stats.append(mean_row, ignore_index=True)

    return df_stats

df_stats_99 = Cal_Stats(lin_array=lin_residual, idw_array=idw_residual, spline_array=spline_residual, percentile=99, ndv=ndv)
df_stats_99.to_csv(outdir+seabed+ '_ErrorStats_' + str(percent)+ '%_99.csv')

df_stats_100 = Cal_Stats(lin_array=lin_residual, idw_array=idw_residual, spline_array=spline_residual, percentile=100, ndv=ndv)
df_stats_100.to_csv(outdir+seabed+ '_ErrorStats_' + str(percent)+ '%_100.csv')

# Pair-wise Interpolation Comparison
def create_data_ttest(idw_residual, linear_residual, spline_residual):
    data = np.hstack((abs(idw_residual).flatten().reshape(-1,1), abs(linear_residual).flatten().reshape(-1,1), abs(spline_residual).flatten().reshape(-1,1)))
    data = pd.DataFrame(data, columns=['IDW', 'Linear', 'Spline']).dropna()

    # Shuffle the data randomly
    data_shuffled = data.sample(frac=1, random_state=42)  # Use a specific random_state for reproducibility

    # Split the shuffled data into three equal parts
    data_part1, data_part2, data_part3 = np.array_split(data_shuffled, 3)

    return data_part1, data_part2, data_part3

df1, df2, df3 = create_data_ttest(idw_residual=idw_residual[0], linear_residual= lin_residual[0], spline_residual=spline_residual[0])

il = df1['IDW'] - df1['Linear']
si = df2['Spline'] - df2['IDW']
sl = df3['Spline'] - df3['Linear']

# il.to_csv(outdir+seabed+'IL_deltaUncertainty_'+str(percent)+'%.csv', index=False)
# si.to_csv(outdir+seabed+'SI_deltaUncertainty_'+str(percent)+'%.csv', index=False)
# sl.to_csv(outdir+seabed+'SL_deltaUncertainty_'+str(percent)+'%.csv', index=False)

# Perform T-test for pair-wise interpolation comparison
il_stat, il_pvalue = stats.ttest_1samp(il, popmean=0, axis=0)
si_stat, si_pvalue = stats.ttest_1samp(si, popmean=0, axis=0)
sl_stat, sl_pvalue = stats.ttest_1samp(sl, popmean=0, axis=0)

pair_stat = pd.DataFrame(data={'IL_stat': [il_stat],
    'IL_Pvalue': [il_pvalue],
    'SI_stat': [si_stat],
    'SI_Pvalue': [si_pvalue],
    'SL_stat': [sl_stat],
    'SL_Pvalue': [sl_pvalue],
    'Samp_density': [percent]
             })
pair_stat.to_csv(outdir+seabed+'_pairwise_stat_'+str(percent)+'%.csv')

il1 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeyIL_deltaUncertainty_1%.csv", index_col=False)
si1 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySI_deltaUncertainty_1%.csv", index_col=False)
sl1 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySL_deltaUncertainty_1%.csv", index_col=False)
il5 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeyIL_deltaUncertainty_5%.csv", index_col=False)
si5 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySI_deltaUncertainty_5%.csv", index_col=False)
sl5 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySL_deltaUncertainty_5%.csv", index_col=False)
il10 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeyIL_deltaUncertainty_10%.csv", index_col=False)
si10 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySI_deltaUncertainty_10%.csv", index_col=False)
sl10 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySL_deltaUncertainty_10%.csv", index_col=False)
il25 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeyIL_deltaUncertainty_25%.csv", index_col=False)
si25 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySI_deltaUncertainty_25%.csv", index_col=False)
sl25 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySL_deltaUncertainty_25%.csv", index_col=False)
il50 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeyIL_deltaUncertainty_50%.csv", index_col=False)
si50 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySI_deltaUncertainty_50%.csv", index_col=False)
sl50 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Stats\Comp\Rough and SlopeySL_deltaUncertainty_50%.csv", index_col=False)

# list of data for each subplot
data = [si1, il1, sl1, si5, il5, sl5, si10, il10, sl10, si25, il25, sl25, si50, il50, sl50]

# Titles for each subplot
titles = ['Spline and IDW', 'IDW and Linear', 'Spline and Linear']

# Sampling densities for each row
sampling_densities = ['1%', '5%', '10%', '25%', '50%']

# Create a 5 by 3 subplot
fig, axes = plt.subplots(nrows=5, ncols=3, figsize=(8, 8), sharex=True, sharey=True, tight_layout=True)

# Loop through subplots
for i in range(5):
    for j in range(3):
        # Calculate the index to access the corresponding data
        idx = i * 3 + j

        # Plot histogram
        axes[i, j].hist(data[idx])

        # Set labels
        if i == 4:  # Last row
            axes[i, j].set_xlabel('Delta Uncertainty (m)')
        if j == 0:  # First column
            axes[i, j].set_ylabel('Frequency')

        # Set titles for the first row
        if i == 0:
            axes[i, j].set_title(titles[j])

        # Add sampling density as a title for each row
        axes[i, j].set_title(f'{sampling_densities[i]} - {titles[j]}')

        # set xlimit
        axes[i, j].set_xlim(-10,10)

        # Label subplots with a, b, c,...
        label = chr(97 + idx)
        axes[i, j].annotate(label, xy=(0.02, 0.85), xycoords='axes fraction', fontsize=12, weight='bold')

# Save and show plot
plt.savefig(outdir + seabed + '_Histogram_of_delta_Uncertainty_10.png', bbox_inches='tight', dpi=600)
plt.show()

# Box plot data
def create_uncertainty_dataframe(idw_residual, linear_residual, spline_residual, density, percentile, take_percentile=True):
    # Calculate the 99th percentile for each array if requested
    idw_df = pd.DataFrame(abs(idw_residual).flatten(), columns=['Uncertainty']).dropna()
    idw_df['Method'] = 'IDW'
    idw_df['Samp_density'] = int(density)

    linear_df = pd.DataFrame(abs(linear_residual).flatten(), columns=['Uncertainty']).dropna()
    linear_df['Method'] = 'Linear'
    linear_df['Samp_density'] = int(density)

    spline_df = pd.DataFrame(abs(spline_residual).flatten(), columns=['Uncertainty']).dropna()
    spline_df['Method'] = 'Spline'
    spline_df['Samp_density'] = int(density)

    if take_percentile:
        idw_percentile = idw_df['Uncertainty'].quantile(percentile/100)
        linear_percentile = linear_df['Uncertainty'].quantile(percentile/100)
        spline_percentile = spline_df['Uncertainty'].quantile(percentile/100)

        # Filter the arrays based on the percentile condition
        idw_array_filtered = idw_df[idw_df['Uncertainty'] < idw_percentile]
        linear_array_filtered = linear_df[linear_df['Uncertainty'] < linear_percentile]
        spline_array_filtered = spline_df[spline_df['Uncertainty'] < spline_percentile]
    else:
        # Use the original arrays without filtering
        idw_array_filtered = idw_df
        linear_array_filtered = linear_df
        spline_array_filtered = spline_df

    # Stack the DataFrames together
    result_dataframe = pd.concat([idw_array_filtered, linear_array_filtered, spline_array_filtered], ignore_index=True)

    return result_dataframe

# data_bp_filt = create_uncertainty_dataframe(idw_residual[0], lin_residual[0], spline_residual[0], density = percent, percentile=99, take_percentile=True)
# data_bp_filt.to_csv(outdir+'Testbed4_8m_7by7_BP_'+str(percent)+'%.csv')
# cb_max = data_bp_filt['Uncertainty'].max()

# format plotting
# Plotting parameters
parameters = {'axes.labelsize': 10,
          'axes.titlesize': 10,
          'xtick.labelsize': 9,
          'ytick.labelsize': 9}
plt.rcParams.update(parameters)

# plot with imshow
def plot_figure(array, title, scale_colour, cb_label):
    plt.figure(figsize=(4,3), dpi=600, tight_layout=True)
    output_extent = [ulx+96, lrx-96, lry+96, uly-96]
    ax = plt.axes()
    plt.ticklabel_format(useOffset=False, style='plain')  # to avoid the display of an offset for the labels
    m2km = lambda x, _: f'{x / 1000:g}' # to convert the data to km
    ax.xaxis.set_major_formatter(m2km)
    ax.yaxis.set_major_formatter(m2km)
    ax.xaxis.set_major_locator(ticker.MultipleLocator(2500))  # to set the distance between labels (x axis) and round to nearest thousand
    ax.yaxis.set_major_locator(ticker.MultipleLocator(3000))
    array_nan = array.copy().astype('float')
    if 0 in array_nan:
        array_nan[array_nan == 0] = np.nan  # set the ndv to nan so as to display the ndv as white color
    else:
        array_nan[array_nan == ndv] = np.nan  # set the ndv to nan so as to display the ndv as white color
    masked_array = np.ma.array(array_nan, mask=np.isnan(array_nan))
    cmap = mpl.cm.jet
    # cmap = mpl.cm.hsv # for roughness
    # cmap = mpl.cm.rainbow # for slope
    cmap.set_bad('white', 1.)
    img = plt.imshow(masked_array, origin='upper', extent=output_extent, cmap=cmap)
    # plt.title(title, fontsize=12)  # put the filename and the projection as part of the title
    plt.xlabel("Easting (km)",labelpad=None)
    plt.ylabel("Northing (km)",labelpad=None)
    cb = plt.colorbar(img, pad=0.02)  # pass the 'img' object used to create the colorbar
    cb.set_label(cb_label, labelpad=None)

    # Add the scale bar
    # scalebar = ScaleBar(1, "m", length_fraction=0.4, height_fraction=0.01, location="lower center",
    #                     font_properties={"size": "x-small"}, sep=1)
    scalebar = ScaleBar(1, "m", length_fraction=0.4, height_fraction=0.01, location="lower center",
                        font_properties={"size": "small"}, sep=1)

    # Customize the scale bar properties
    scalebar.set_color(scale_colour)
    scalebar.set_box_color(scale_colour)
    scalebar.set_box_alpha(0)

    ax.add_artist(scalebar)

    plt.savefig(outdir + title + '.png', bbox_inches='tight', dpi=600)
    plt.interactive(False)
    plt.show()
    # plt.close()

# quick plots
# plot_figure(depth, scale_colour= 'white', title= seabed.capitalize() +' seabed, ' + str(int(x_res)) +'m resolution', cb_label='Bathymetry (m)')
# plot_figure(idw_interp[0], scale_colour= 'black', title= seabed.capitalize() +' seabed, IDW Interpolation, ' + str(percent) +'% Sampling', cb_label='Bathymetry (m)')
# plot_figure(lin_interp[0], scale_colour= 'black', title= seabed.capitalize() +' seabed, Linear Interpolation, ' + str(percent) +'% Sampling', cb_label='Bathymetry (m)')
# plot_figure(spline_interp[0], scale_colour= 'black', title= seabed.capitalize() +' seabed, Spline Interpolation, ' + str(percent) +'% Sampling', cb_label='Bathymetry (m)')

# Plot with scatter
# %%
def plot_figure_scatter(array, scale_colour, coordinate, percentile, title, marker, cb_label, take_absolute, cb_min, cb_max):
    plt.figure(figsize=(4, 3), dpi=600, tight_layout=True)

    # Handle no-data values
    if 0 in array:
        array[array == 0] = np.nan  # set the ndv to nan so as to display the ndv as white color
    else:
        array[array == ndv] = np.nan  # set the ndv to nan so as to display the ndv as white color

    # Choose whether to take the absolute value of the array
    array = abs(array) if take_absolute else array

    # Flatten and reshape the array
    array = array.flatten().reshape(-1, 1)

    # Combine the coordinate and array data into a DataFrame
    df = pd.DataFrame(np.hstack((coordinate, array)), columns=['x', 'y', 'z']).dropna()

    # Sort the DataFrame by the 'z' column
    df_sorted = df.sort_values(by='z', ignore_index=True)

    # Calculate the percentile value
    percentile_value = df_sorted['z'].quantile(percentile / 100)

    # Filter the DataFrame based on the percentile
    # sliced_df = df_sorted[df_sorted <= percentile_value]
    idx = df_sorted.loc[df_sorted['z'] >= percentile_value].index
    sliced_df = df_sorted.iloc[0:idx[0]] if not idx.empty else df_sorted

    # Create the scatter plot
    colors = mpl.cm.jet
    scatter = plt.scatter(sliced_df.x.values, sliced_df.y.values, c=sliced_df.z.values, cmap=colors, s=0.01, marker=marker, vmin=cb_min, vmax=cb_max)
    cbar = plt.colorbar(scatter, pad=0.02)
    cbar.set_label(cb_label, labelpad=None)

    # Set axis labels
    plt.xlabel("Easting (km)",labelpad=None)
    plt.ylabel("Northing (km)",labelpad=None)

    # Configure tick labels
    ax = plt.gca()
    plt.ticklabel_format(useOffset=False, style='plain')

    # Convert data to km
    m2km = lambda x, _: f'{x / 1000:g}'
    ax.xaxis.set_major_formatter(m2km)
    ax.yaxis.set_major_formatter(m2km)

    # Set axis intervals
    ax.xaxis.set_major_locator(ticker.MultipleLocator(2500))
    ax.yaxis.set_major_locator(ticker.MultipleLocator(3000))

    # Set plot extent
    plt.xlim(ulx + (res*cell_number), lrx - (res*cell_number))
    plt.ylim(lry + (res*cell_number), uly - (res*cell_number))

    # Add scale bar
    scalebar = ScaleBar(1, "m", length_fraction=0.4, height_fraction=0.01, location="lower center",
                        font_properties={"size": "small"}, sep=1)
    scalebar.set_color(scale_colour)
    scalebar.set_box_color(scale_colour)
    scalebar.set_box_alpha(0)
    ax.add_artist(scalebar)

    # Save and display the plot
    plt.savefig(outdir + title + '.png', bbox_inches='tight', dpi=600)
    plt.interactive(False)
    # plt.show()
    plt.close()

plot_figure_scatter(idw_residual[0], scale_colour= 'black', coordinate= xy_coordinates_bound, percentile=99, marker ='.', title= seabed.capitalize() +' Seabed Residual, ' + str(percent) +'% Sampling_IDW_CBN_Black',
                      cb_label='Interpolation Uncertainty (m)', take_absolute=True, cb_min=None, cb_max=None)
# plot_figure_scatter(lin_residual[0], scale_colour= 'white', coordinate= xy_coordinates_bound, percentile=99, marker ='.', title= seabed.capitalize() +' Seabed Residual, ' + str(percent) +'% Sampling_Linear_CBN',
#                       cb_label='Interpolation Uncertainty (m)', take_absolute=True, cb_min=None, cb_max=None)
# plot_figure_scatter(spline_residual[0], scale_colour= 'white', coordinate= xy_coordinates_bound, percentile=99, marker ='.', title= seabed.capitalize() +' Seabed Residual, ' + str(percent) +'% Sampling_Spline_CBN',
#                       cb_label='Interpolation Uncertainty (m)', take_absolute=True, cb_min=None, cb_max=None)
# plot_figure_scatter(idw_slope[0], scale_colour= 'white', coordinate= xy_coordinates_bound, percentile=99, marker ='.', title= seabed.capitalize() +' IDW Slope, ' + str(percent) +'% Sampling_99',
#                       cb_label='Slope (degree)', take_absolute=True, cb_min=None, cb_max=None)
# plot_figure_scatter(idw_roughness[0], scale_colour= 'white', coordinate= xy_coordinates_bound, percentile=99, marker ='.', title= seabed.capitalize() +' IDW Roughness, ' + str(percent) +'% Sampling_99',
#                       cb_label='Roughness (degree)', take_absolute=True, cb_min=None, cb_max=None)
# plot_figure_scatter(distance_array[0], scale_colour= 'white', coordinate= xy_coordinates_bound, percentile=100, marker ='s', title= seabed.capitalize() +' Distance to nearest measurement, ' + str(percent) +'% Sampling',
#                       cb_label='Distance (pixel)', take_absolute=True, cb_min=None, cb_max=None)
# plot_figure_scatter(train_bound[0], scale_colour= 'black', coordinate= xy_coordinates, percentile=100, marker ='s', title=seabed.capitalize() + ' Seabed Train Data, ' + str(percent) + '% Sampling',
#             cb_label='Bathymetry (m)', take_absolute=False, cb_min=None, cb_max=None)

#Distance Plotting only
# %%
def plot_figure_scatter(array, scale_colour, coordinate, percentile, title, marker, cb_label, take_absolute, buffer):
    plt.figure(figsize=(4, 3), dpi=600, tight_layout=True)
    # plt.figure(figsize=(4, 3), dpi=600, tight_layout=True)
    # Handle no-data values
    if 0 in array:
        array[array == 0] = np.nan  # set the ndv to nan so as to display the ndv as white color
    else:
        array[array == ndv] = np.nan  # set the ndv to nan so as to display the ndv as white color

    # Choose whether to take the absolute value of the array
    array = abs(array) if take_absolute else array

    # Flatten and reshape the array
    array = array.flatten().reshape(-1, 1)

    # Combine the coordinate and array data into a DataFrame
    df = pd.DataFrame(np.hstack((coordinate, array)), columns=['x', 'y', 'z']).dropna()

    # Sort the DataFrame by the 'z' column
    df_sorted = df.sort_values(by='z', ignore_index=True)

    # Calculate the percentile value
    percentile_value = df_sorted['z'].quantile(percentile / 100)

    # Filter the DataFrame based on the percentile
    sliced_df = df_sorted[df_sorted <= percentile_value].dropna()
    # idx = df_sorted.loc[df_sorted['z'] >= percentile_value].index
    # sliced_df = df_sorted.iloc[0:idx[0]] if not idx.empty else df_sorted

    # Create the scatter plot
    colors = mpl.cm.jet
    scatter = plt.scatter(sliced_df.x.values, sliced_df.y.values, c=sliced_df.z.values, cmap=colors, s=0.01, marker=marker)
    cbar = plt.colorbar(scatter, pad=0.02)
    cbar.set_label(cb_label, labelpad=None, fontsize = '8')

    # Set axis labels
    plt.xlabel("Easting (km)",labelpad=None)
    plt.ylabel("Northing (km)",labelpad=None)

    # Configure tick labels
    ax = plt.gca()
    plt.ticklabel_format(useOffset=False, style='plain')

    # Convert data to km
    m2km = lambda x, _: f'{x / 1000:g}'
    ax.xaxis.set_major_formatter(m2km)
    ax.yaxis.set_major_formatter(m2km)

    # Set axis intervals
    ax.xaxis.set_major_locator(ticker.MultipleLocator(2500))
    ax.yaxis.set_major_locator(ticker.MultipleLocator(3000))

    # Set plot extent
    plt.xlim(ulx + (res*cell_number), lrx - (res*cell_number))
    plt.ylim(lry + (res*cell_number), uly - (res*cell_number))

    # Add scale bar
    scalebar = ScaleBar(1, "m", length_fraction=0.4, height_fraction=0.01, location="lower center",
                        font_properties={"size": "small"}, sep=1)
    scalebar.set_color(scale_colour)
    scalebar.set_box_color(scale_colour)
    scalebar.set_box_alpha(0)
    ax.add_artist(scalebar)

    if buffer:
        output_extent = [ulx, lrx, lry, uly]

        boundary_distance = 24
        # Calculate the expanded extent within the original extent
        expanded_extent = [
            max(output_extent[0] + boundary_distance * x_res, ulx),  # Ensure left is within the main boundary
            min(output_extent[1] - boundary_distance * x_res, lrx),  # Ensure right is within the main boundary
            max(output_extent[2] + boundary_distance * abs(y_res), lry),  # Ensure bottom is within the main boundary
            min(output_extent[3] - boundary_distance * abs(y_res), uly)  # Ensure top is within the main boundary
        ]

        # Plot the expanded boundary with a different color
        plt.plot([expanded_extent[0], expanded_extent[1], expanded_extent[1], expanded_extent[0], expanded_extent[0]],
                 [expanded_extent[2], expanded_extent[2], expanded_extent[3], expanded_extent[3], expanded_extent[2]],
                 color='red', linestyle='--', linewidth=1.5)

    # Save and display the plot
    plt.savefig(outdir + title + '.png', bbox_inches='tight', dpi=600)
    plt.interactive(False)
    plt.show()
    # plt.close()

# plot_figure_scatter(distance_array[0], scale_colour= 'black', coordinate= xy_coordinates_bound, percentile=100, marker ='s', title= seabed.capitalize() +' Distance to nearest measurement, ' + str(percent) +'% Sampling',
#                       cb_label='Distance to nearest measurement (pixel)', take_absolute=True, buffer=True)

# Min and Max Values
# Calculate the min and max of the interpolation uncertainty
def calculate_min_max_stats(data_array, percentile):
    df_min_max_ci = pd.DataFrame(columns=['no', 'min', 'max', 'min_percentile', 'max_percentile'])

    no_of_iter = len(data_array)

    for i in range(no_of_iter):

        data = abs(data_array[i])

        # calculate the percentile
        percentile_value = np.nanpercentile(data, percentile)

        # Append data to the DataFrame
        df_min_max_ci = df_min_max_ci.append({
            'no': i,
            'min': np.nanmin(data),
            'max': np.nanmax(data),
            'min_percentile': np.nanmin(data[data <= percentile_value]),
            'max_percentile': np.nanmax(data[data <= percentile_value]),
        }, ignore_index=True)

    return df_min_max_ci

# data_idw = idw_residual
# data_lin = lin_residual
# data_spline = spline_residual
# idw_min_max_stats = calculate_min_max_stats(data_idw, percentile=99)
# lin_min_max_stats = calculate_min_max_stats(data_lin, percentile=99)
# spline_min_max_stats = calculate_min_max_stats(data_spline, percentile=99)
# idw_min_max_stats.to_csv(outdir+seabed.capitalize() + '_' + str(percent) +'%_Min_Max_IDW.csv')
# lin_min_max_stats.to_csv(outdir+seabed.capitalize() + '_' + str(percent) +'%_Min_Max_Lin.csv')
# spline_min_max_stats.to_csv(outdir+seabed.capitalize() + '_' + str(percent) +'%_Min_Max_Spline.csv')

# Plot Box and Whisker
bp1 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Spatial_scale\Random\Rough_Slopey\Window_size\7by7\1%\Testbed4_8m_7by7_BP_1%.csv")
bp1_lin = bp1.loc[bp1['Method']=='Linear','Uncertainty'].values
bp1_idw = bp1.loc[bp1['Method']=='IDW','Uncertainty'].values
bp1_spline = bp1.loc[bp1['Method']=='Spline','Uncertainty'].values
bp5 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Spatial_scale\Random\Rough_Slopey\Window_size\7by7\5%\Testbed4_8m_7by7_BP_5%.csv")
bp5_lin = bp5.loc[bp5['Method']=='Linear','Uncertainty'].values
bp5_idw = bp5.loc[bp5['Method']=='IDW','Uncertainty'].values
bp5_spline = bp5.loc[bp5['Method']=='Spline','Uncertainty'].values
bp10 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Spatial_scale\Random\Rough_Slopey\Window_size\7by7\10%\Testbed4_8m_7by7_BP_10%.csv")
bp10_lin = bp10.loc[bp10['Method']=='Linear','Uncertainty'].values
bp10_idw = bp10.loc[bp10['Method']=='IDW','Uncertainty'].values
bp10_spline = bp10.loc[bp10['Method']=='Spline','Uncertainty'].values
bp25 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Spatial_scale\Random\Rough_Slopey\Window_size\7by7\25%\Testbed4_8m_7by7_BP_25%.csv")
bp25_lin = bp25.loc[bp25['Method']=='Linear','Uncertainty'].values
bp25_idw = bp25.loc[bp25['Method']=='IDW','Uncertainty'].values
bp25_spline = bp25.loc[bp25['Method']=='Spline','Uncertainty'].values
bp50 = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Spatial_scale\Random\Rough_Slopey\Window_size\7by7\50%\Testbed4_8m_7by7_BP_50%.csv")
bp50_lin = bp50.loc[bp50['Method']=='Linear','Uncertainty'].values
bp50_idw = bp50.loc[bp50['Method']=='IDW','Uncertainty'].values
bp50_spline = bp50.loc[bp50['Method']=='Spline','Uncertainty'].values

# format plotting
# Plotting parameters
parameters = {'axes.labelsize': 20,
          'axes.titlesize': 20,
          'xtick.labelsize': 20,
          'ytick.labelsize': 20}
plt.rcParams.update(parameters)

fig, (ax1, ax2, ax3, ax4, ax5) = plt.subplots(1, 5, figsize=(20, 5), sharex=False, sharey=True)
ax1.boxplot([bp1_idw, bp1_lin, bp1_spline], labels=['IDW', 'Linear', 'Spline'], showfliers=False)
ax1.set_ylabel('Interpolation Uncertainty (m)')
ax1.set_title('1% Sampling Density')

ax2.boxplot([bp5_idw, bp5_lin, bp5_spline], labels=['IDW', 'Linear', 'Spline'], showfliers=False)
ax2.set_title('5% Sampling Density')

ax3.boxplot([bp10_idw, bp10_lin, bp10_spline], labels=['IDW', 'Linear', 'Spline'], showfliers=False)
ax3.set_xlabel('Interpolation Method', labelpad=10)
ax3.set_title('10% Sampling Density')

ax4.boxplot([bp25_idw, bp25_lin, bp25_spline], labels=['IDW', 'Linear', 'Spline'], showfliers=False)
ax4.set_title('25% Sampling Density')

ax5.boxplot([bp50_idw, bp50_lin, bp50_spline], labels=['IDW', 'Linear', 'Spline'], showfliers=False)
ax5.set_title('50% Sampling Density')

fig.tight_layout()
plt.savefig(outdir + seabed + '_Testbed4_7by7_boxplot_sharedy_nofliers.png')
plt.show()


# Put together all the residuals and distances from all surfaces and remove the train data (i.e the nans)
def stack_all_parameters(res_array, dist_array, slope_array, roughness_array,x_coordinate, y_coordinate, filter=True):
    dfs = []
    for dist, res, slope, roughness in zip(dist_array, res_array, slope_array, roughness_array, ):
        stacked_array = np.column_stack((dist.flatten(), np.abs(res).flatten(),
                                         slope.flatten(), roughness.flatten(),
                                         pd.DataFrame(x_coordinate), pd.DataFrame(y_coordinate)))
        df = pd.DataFrame(stacked_array, columns=['distance', 'residual', 'slope', 'roughness', 'easting', 'northing'])
        df.replace([np.inf, -np.inf], np.nan, inplace=True)
        df.dropna(inplace=True)
        dfs.append(df)

    df = pd.concat(dfs, ignore_index=True)


    if filter:
        df = df.sort_values(by='slope').reset_index(drop=True)
        df['Difference'] = df['slope'].diff()
        max_difference = df['Difference'].max()
        find_idx = df[df['Difference'] == max_difference].index[0] - 1
        df = df.loc[:find_idx].drop('Difference', axis=1)

    return df

lin_parameters_array = stack_all_parameters(res_array=lin_residual, dist_array=distance_array,slope_array=lin_slope, roughness_array=lin_roughness,
                                            x_coordinate=x_coordinates_bound, y_coordinate=y_coordinates_bound, filter=True)
spline_parameters_array = stack_all_parameters(res_array=spline_residual, dist_array=distance_array, slope_array=spline_slope, roughness_array=spline_roughness,
                                               x_coordinate=x_coordinates_bound, y_coordinate=y_coordinates_bound, filter=True)
idw_parameters_array = stack_all_parameters(res_array=idw_residual,dist_array=distance_array, slope_array=idw_slope, roughness_array=idw_roughness,
                                            x_coordinate=x_coordinates_bound, y_coordinate=y_coordinates_bound, filter=True)

lin_parameters_array.to_csv(f"{outdir}{seabed.capitalize()}_{percent}%_lin parameters array.csv",index=False)
spline_parameters_array.to_csv(f"{outdir}{seabed.capitalize()}_{percent}%_spline parameters array.csv",index=False)
idw_parameters_array.to_csv(f"{outdir}{seabed.capitalize()}_{percent}%_idw parameters array.csv",index=False)

print('stacked all parameters, time:',datetime.now())

# Get rid of the unneeded files
# del train_bound, train_data, test_bound, test_data, test_inbound_index, test_bound_new,
# del spline_roughness, idw_residual, idw_slope, idw_roughness, spline_interp, lin_interp, idw_interp, lin_interp_tif, spline_interp_tif, idw_interp_tif, grid_idw, grid_x, grid_y, df_train,
# del df_complete
# del lin_residual, distance_array, lin_slope, lin_roughness, spline_residual, spline_slope

# Get rid of the unneeded files
# variables_to_delete = [
#     train_bound, train_data, test_bound, test_data, test_inbound_index,
#     test_bound_new,  lin_interp_tif,
#     spline_interp_tif, idw_interp_tif, grid_idw, grid_x, grid_y, df_train,
#     df_complete, depth_raw, depth_outbound, depth_inbound
# ]

# total_size = sum(sys.getsizeof(variable) for variable in variables_to_delete)
# print(f"Total size of variables: {total_size} bytes")

# others = [lin_residual, distance_array, lin_slope, lin_roughness, spline_residual, spline_slope,spline_roughness, idw_residual, idw_slope, idw_roughness]

# total_size = sum(sys.getsizeof(variable) for variable in others)
# print(f"Total size of variables: {total_size} bytes")

# Delete variables using a loop
# for variable in variables_to_delete:
#     del variable
#
# for variable in others:
#     del variable


# Define the names of the statsummary files.
lrstat = seabed + '_' + str(percent)+'%_random_lr_stats.csv'
mvrstat = seabed + '_' + str(percent)+'%_random_mvr_stats_int.csv'
mvrstat1 = seabed + '_' + str(percent)+'%_random_mvr_stats_noint.csv'
nnstat = seabed + '_' + str(percent)+'%_random_nn_stats.csv'

def linear_regression(parameters_array, samp_density, par1, par2, interpolator, location, seabed, outdir, x_res):
    dfstatsumm = pd.DataFrame()

    labels = {
        'distance': 'Distance to nearest measurement (pixel)',
        'residual': 'Absolute Residual (m)',
        'slope': 'Slope (degree)',
        'roughness': 'Roughness (degree)'
    }

    data = parameters_array[[par1, par2]]
    formula = f"{par1}~{par2}"
    model = smf.ols(formula, data).fit()

    print(model.summary())

    # Calculate the estimated uncertainty using the model
    data['estimate'] = model.predict(data[par2])

    # Dataframe for R Squared and RMSE
    dfstat = pd.DataFrame(data={
        'area': [location],
        'seabed_type': [seabed],
        'interp_method': [interpolator],
        'resolution': [x_res],
        'Sampling_density': [int(samp_density)],
        'variable': [par2],
        'num_obs': [model.nobs],
        'rsqradj': [model.rsquared_adj],
        'f_pvalue': [model.f_pvalue],
        'rmse': model.mse_resid ** 0.5,
        'intercept': model.params[0],
        'slope': model.params[1],
        'coeff_pvalue': model.pvalues[0],
        't_value': model.tvalues[1],
        'coeff_tvalue': model.tvalues[0]
    })


    plt.ioff()
    plt.figure(tight_layout=True)
    plt.scatter(data[par2], data[par1], label='test samples', s=3)
    plt.plot(data[par2], data.estimate, label='regression line', color='r')
    plt.xlabel(labels.get(par2, par2))
    plt.ylabel(labels.get(par1, par1))
    title = f"{interpolator.capitalize()} interpolator; {seabed.capitalize()} seabed, Sampling density: {int(samp_density)}% " \
            f"rsqradj: {round(model.rsquared_adj, 3)} rmse: {round(model.mse_resid ** 0.5, 3)}"
    plt.title(title, fontsize=10)
    plt.legend(fontsize=10, loc=1)
    plt.savefig(
        f"{outdir}{seabed}_{location}_{interpolator}_{par2}_{int(samp_density)}%.png",
        bbox_inches='tight'
    )
    # plt.show()
    plt.close('all')

    return dfstat, model

# # regression of distance against residual
dfstatsumm = pd.DataFrame()
dfsigsumm = pd.DataFrame()
dfstat_lin_distance, dfmodel_lin_distance= linear_regression(parameters_array=lin_parameters_array, samp_density=percent,
                                     par1='residual', par2='distance', interpolator='Linear', location=location, seabed=seabed, outdir=outdir, x_res = x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_lin_distance], axis=0)

#
dfstat_spline_distance, dfmodel_spline_distance = linear_regression(parameters_array=spline_parameters_array, samp_density=percent,
                                     par1='residual', par2='distance', interpolator='Spline', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_spline_distance], axis=0)

#
dfstat_idw_distance, dfmodel_idw_distance = linear_regression(parameters_array=idw_parameters_array, samp_density=percent,
                                     par1='residual', par2='distance', interpolator='IDW', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_idw_distance], axis=0)

# regression of slope against residual
dfstat_lin_slope, dfmodel_lin_slope= linear_regression(parameters_array=lin_parameters_array, samp_density=percent,
                                     par1='residual', par2='slope', interpolator='Linear', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_lin_slope], axis=0)


dfstat_spline_slope, dfmodel_spline_slope = linear_regression(parameters_array=spline_parameters_array, samp_density=percent,
                                     par1='residual', par2='slope', interpolator='Spline', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_spline_slope], axis=0)

dfstat_idw_slope, dfmodel_idw_slope = linear_regression(parameters_array=idw_parameters_array, samp_density=percent,
                                     par1='residual', par2='slope', interpolator='IDW', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_idw_slope], axis=0)

# regression of roughness against residual
dfstat_lin_roughness, dfmodel_lin_roughness = linear_regression(parameters_array=lin_parameters_array, samp_density=percent,
                                     par1='residual', par2='roughness', interpolator='Linear', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_lin_roughness], axis=0)

dfstat_spline_roughness, dfmodel_spline_roughness = linear_regression(parameters_array=spline_parameters_array, samp_density=percent,
                                     par1='residual', par2='roughness', interpolator='Spline', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_spline_roughness], axis=0)

dfstat_idw_roughness, dfmodel_idw_roughness = linear_regression(parameters_array=idw_parameters_array, samp_density=percent,
                                     par1='residual', par2='roughness', interpolator='IDW', location=location, seabed=seabed, outdir=outdir, x_res=x_res)
dfstatsumm = pd.concat([dfstatsumm, dfstat_idw_roughness], axis=0)

# Output the Statsummary file
dfstatsumm.to_csv(outdir+lrstat,index=False)

print('linear regression completed, time:',datetime.now())


#MVR
# Define the names of the statsummary files.

mvrstat = seabed + '_' + str(percent)+'%_random_mvr_stats_int.csv'
mvrstat1 = seabed + '_' + str(percent)+'%_random_mvr_stats_noint.csv'

def multivariate_regression(parameters_array, samp_density, interpolator, location, seabed, outdir, x_res, interaction=True):
    if interaction:
        parameters_array['sd'] = parameters_array['slope'] * parameters_array['distance']
        parameters_array['sr'] = parameters_array['slope'] * parameters_array['roughness']
        parameters_array['rd'] = parameters_array['distance'] * parameters_array['roughness']
        parameters_array['srd'] = parameters_array['slope'] * parameters_array['roughness'] * parameters_array['distance']

        # Perform multivariate regression
        model = smf.ols('residual ~ distance + slope + roughness + sd + sr + rd + srd', data=parameters_array).fit()
        summary_df = pd.read_html(model.summary().tables[1].as_html(), header=0, index_col=0)[0]
        summary_df.to_csv(f"{outdir}{seabed.capitalize()}_{interpolator}_{int(samp_density)}%_MVR_model_summary_int.csv",
                          index=True)
        print(model.summary())

    else:
        # Perform multivariate regression
        model = smf.ols('residual ~ distance + slope + roughness', data=parameters_array).fit()
        summary_df = pd.read_html(model.summary().tables[1].as_html(), header=0, index_col=0)[0]
        summary_df.to_csv(f"{outdir}{seabed.capitalize()}_{interpolator}_{int(samp_density)}%_MVR_model_summary_noint.csv", index=True)
        print(model.summary())

    # Add estimated values to the DataFrame
    parameters_array['estimate'] = model.predict(parameters_array)

    # Fit a regression model for estimated residual
    df_res_est_model = smf.ols('estimate ~ residual', data=parameters_array).fit()
    print(df_res_est_model.summary())

    # Create the DataFrame for result statistics
    dfmvrstat = pd.DataFrame(data={
        'area': [location],
        'seabed_type': [seabed],
        'interp_method': [interpolator],
        'ML_method': ['MVR'],
        'resolution': [x_res],
        'line_spacing': [int(samp_density)],
        'variable': ['estimated residual'],
        'num_obs': [df_res_est_model.nobs],
        'rsqradj': [df_res_est_model.rsquared_adj],
        'f_pvalue': [df_res_est_model.f_pvalue],
        'rmse': np.sqrt(df_res_est_model.mse_resid),
        'intercept': [df_res_est_model.params[0]],
        'slope': [df_res_est_model.params[1]],
        'coeff_pvalue': [df_res_est_model.pvalues[0]]
    })

    plt.ioff()
    plt.figure(tight_layout=True)
    plt.scatter(parameters_array.residual, parameters_array.estimate, label='Test Samples', s=3)
    plt.plot(parameters_array.residual, df_res_est_model.fittedvalues, color='r', label='Regression Line')
    plt.xlabel('Residual (m)', fontsize=10)
    plt.ylabel('Estimated residual (m)', fontsize=10)
    plt.title(
        f"{interpolator.capitalize()} interpolator; MVR, {seabed.capitalize()} seabed, "
        f"Sampling density: {int(samp_density)}%, rsqradj: {round(df_res_est_model.rsquared_adj, 3)}, "
        f"rmse: {round(df_res_est_model.mse_resid ** 0.5, 3)}",
        fontsize=10
    )
    plt.legend(fontsize=10, loc=1)
    plt.savefig(outdir + f"{seabed}_{location}_{interpolator}_MVR_EstRes_{int(samp_density)}%.png", bbox_inches='tight')
    plt.close()

    return dfmvrstat, df_res_est_model

# lin_parameters_array = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Rough_Slopey\25%\Rough_slopey_25%_lin parameters array.csv")
# spline_parameters_array = pd.read_csv("C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Flat\1%\Flat_1%_spline parameters array.csv")
# idw_parameters_array = pd.read_csv(r"C:\Users\eadediran\OneDrive - USNH\Documents\Thesis\Results\Random\Rough_Slopey\25%\Rough_slopey_25%_idw parameters array.csv")

lin_mvrstatsumm,lin_res_est_model= multivariate_regression(parameters_array=lin_parameters_array, samp_density=percent,
                                        interpolator='Linear', location=location, seabed=seabed, outdir=outdir, x_res=x_res, interaction=False)
spline_mvrstatsumm,spline_res_est_model = multivariate_regression(parameters_array=spline_parameters_array, samp_density=percent,
                                        interpolator='Spline', location=location, seabed=seabed, outdir=outdir, x_res=x_res, interaction=False)
idw_mvrstatsumm,idw_res_est_model = multivariate_regression(parameters_array=idw_parameters_array, samp_density=percent,
                                        interpolator='IDW', location=location, seabed=seabed, outdir=outdir, x_res=x_res, interaction=False)
#
mvrstatsumm = pd.DataFrame()
mvrstatsumm = pd.concat([mvrstatsumm, lin_mvrstatsumm, spline_mvrstatsumm, idw_mvrstatsumm], axis=0)
mvrstatsumm.to_csv(outdir+mvrstat1,index=False)

lin_mvrstatsumm,lin_res_est_model = multivariate_regression(parameters_array=lin_parameters_array, samp_density=percent,
                                        interpolator='Linear', location=location, seabed=seabed, outdir=outdir, x_res=x_res, interaction=True)
spline_mvrstatsumm,spline_res_est_model = multivariate_regression(parameters_array=spline_parameters_array, samp_density=percent,
                                        interpolator='Spline', location=location, seabed=seabed, outdir=outdir, x_res=x_res, interaction=True)
idw_mvrstatsumm,idw_res_est_model = multivariate_regression(parameters_array=idw_parameters_array, samp_density=percent,
                                        interpolator='IDW', location=location, seabed=seabed, outdir=outdir, x_res=x_res, interaction=True)

mvrstatsumm = pd.DataFrame()
mvrstatsumm = pd.concat([mvrstatsumm, lin_mvrstatsumm, spline_mvrstatsumm, idw_mvrstatsumm], axis=0)
mvrstatsumm.to_csv(outdir+mvrstat,index=False)

#RF
rfstat = seabed + '_' + str(percent)+'%_random_rf_stats.csv'

def random_forest(multi_array, samp_density, interpolator, resolution, location, seabed, outdir, plot=True):
    data = multi_array.copy()
    yVar = data['residual']
    xVars = data[['distance', 'slope', 'roughness']]

    X_train, X_test, y_train, y_test = train_test_split(xVars, yVar, train_size=0.7, random_state=2)

    scaler = StandardScaler()
    scaler.fit(X_train)
    X_train_scaled = scaler.transform(X_train)
    X_test_scaled = scaler.transform(X_test)

    rf_model = RandomForestRegressor(n_estimators=10, random_state=30)
    rf_model.fit(X_train_scaled, y_train)

    y_pred_RF = rf_model.predict(X_test_scaled)

    # Adjusted rsq
    y_pred_test_RF = pd.DataFrame({'residual': y_test.reset_index(drop=True), 'estimate': y_pred_RF})
    y_pred_test_RF_model = smf.ols('estimate~residual', y_pred_test_RF).fit()

    # Feature ranking
    feature_imp = pd.Series(rf_model.feature_importances_, index=xVars.columns).sort_values()

    dfrfstat = pd.DataFrame(data={
        'area': [location],
        'seabed_type': [seabed],
        'interp_method': [interpolator],
        'ML_method': ['RF'],
        'resolution': [resolution],
        'line_spacing': [samp_density],
        'variable': ['estimated residual'],
        'dist_importance': [feature_imp[0]],
        'slp_importance': [feature_imp[1]],
        'rgn_importance': [feature_imp[2]],
        'num_obs': [y_pred_test_RF_model.nobs],
        'rsqradj': [y_pred_test_RF_model.rsquared_adj],
        'f_pvalue': [y_pred_test_RF_model.f_pvalue],
        'rmse': np.sqrt(y_pred_test_RF_model.mse_resid),
        'intercept': [y_pred_test_RF_model.params[0]],
        'slope': [y_pred_test_RF_model.params[1]],
        'coeff_pvalue': [y_pred_test_RF_model.pvalues[0]]
    })


    if plot:
        plt.ioff()
        plt.figure(tight_layout=True)
        plt.scatter(y_test, y_pred_RF, label='Test Samples', s=3)
        plt.plot(y_test, y_pred_test_RF_model.predict(y_pred_test_RF), color='r', label='Regression Line')
        plt.xlabel('Residual (m)', fontsize=10)
        plt.ylabel('Estimated residual (m)', fontsize=10)
        plt.title(
            f"{interpolator.capitalize()} interpolator; RF, {seabed.capitalize()} seabed, "
            f"Sampling density: {int(samp_density)}%, "
            f"rsqradj: {round(y_pred_test_RF_model.rsquared_adj, 3)}, "
            f"rmse: {round(y_pred_test_RF_model.mse_resid ** 0.5, 3)}",
            fontsize=10
        )
        plt.legend(fontsize=10,loc=1)
        plt.savefig(
            outdir + f"{seabed}_{location}_{interpolator}_RF_EstRes_{int(samp_density)}%30.png",
            bbox_inches='tight'
        )
        plt.close()

    return dfrfstat, y_pred_test_RF_model, feature_imp

# lin_rfstat, lin_rf_model, lin_rf_featimp = random_forest(lin_parameters_array, percent, 'Linear', x_res,
#                                                            location, seabed, outdir, plot=False)
# spl_rfstat, spl_rf_model, spl_rf_featimp = random_forest(spline_parameters_array, percent, 'Spline', x_res,
#                                                            location, seabed, outdir, plot=False)
# idw_rfstat, idw_rf_model, idw_rf_featimp = random_forest(idw_parameters_array, percent, 'IDW', x_res,
#                                                            location, seabed, outdir, plot=False)
#
# rfstatsumm = pd.DataFrame()
# rfstatsumm = pd.concat([rfstatsumm, lin_rfstat, spl_rfstat, idw_rfstat], axis=0)
# rfstatsumm.to_csv(outdir+rfstat,index=False)

# print('Random forest completed, time:',datetime.now())

print('RF BS start, time:',datetime.now())

# New implementation of RF with bootstrap
bsrfstat = seabed + '_' + str(percent)+'%_random_rf_stats_bs_updated_10%data.csv'
bsrfimp = seabed + '_' + str(percent)+'%_random_rf_imp_bs_10%data.csv'

def random_forest_bootstrap(multi_array, samp_density, interpolator, resolution, location, seabed, outdir, n_tree, percent, n_bootstrap):
    # define variable
    # n_tree is the number of estimators for RF, i.e., no of trees
    # n_bootstrap is the number of bootstrap
    data = multi_array.copy()
    yVar = data['residual']
    xVars = data[['distance', 'slope', 'roughness']]

    # Skip train_test_split and use all data for training
    X_train_scaled = StandardScaler().fit_transform(xVars)
    y_train = yVar

    # Initialize an empty DataFrame to store feature importances
    feature_imp_df = pd.DataFrame()
    feature_imp_db_df = pd.DataFrame()

    for _ in range(n_bootstrap):
        # Perform bootstrapping by sampling a specified percent of data
        bootstrap_indices = np.random.choice(len(X_train_scaled), size=int((percent/100) * len(X_train_scaled)), replace=True)
        X_train_boot = X_train_scaled[bootstrap_indices]
        y_train_boot = y_train.iloc[bootstrap_indices]

        rf_model = RandomForestRegressor(n_estimators=n_tree, random_state=30)
        rf_model.fit(X_train_boot, y_train_boot)

        # Feature ranking
        feature_imp = pd.Series(rf_model.feature_importances_, index=xVars.columns).sort_values()

        # Concatenate feature importances to the DataFrame
        feature_imp_df = feature_imp_df.append(feature_imp, ignore_index=True)

    # # # Calculate mean feature importance across bootstrap runs
    mean_feature_imp = feature_imp_df.mean(axis=0)

    # Calculate standard error for each feature
    # se_feature_imp = feature_imp_df.sem(axis=0)

    # Calculate the 95% confidence interval for each feature
    ci_low = feature_imp_df.quantile(0.025)
    ci_high = feature_imp_df.quantile(0.975)

    dfrfstat = pd.DataFrame(data={
        'seabed_type': [seabed],
        'interp_method': [interpolator],
        'resolution': [resolution],
        'samp_density': [samp_density],
        'variable': ['combined'],
        'mean_dist_importance': [mean_feature_imp.loc['distance']],
        'mean_slp_importance': [mean_feature_imp.loc['slope']],
        'mean_rgn_importance': [mean_feature_imp.loc['roughness']],
        'num_obs_sb': [len(y_train_boot)],
        'ci_dist_lower': [round(ci_low['distance'], 5)],
        'ci_dist_upper': [round(ci_high['distance'], 5)],
        'ci_slp_lower': [round(ci_low['slope'], 5)],
        'ci_slp_upper': [round(ci_high['slope'], 5)],
        'ci_rgn_lower': [round(ci_low['roughness'], 5)],
        'ci_rgn_upper': [round(ci_high['roughness'], 5)]
    })

    return dfrfstat, feature_imp_df

lin_rfstat, lin_rf_featimp = random_forest_bootstrap(lin_parameters_array, percent, 'Linear', x_res,
                                                           location, seabed, outdir, n_tree=10, percent=10, n_bootstrap=500)
spl_rfstat, spl_rf_featimp= random_forest_bootstrap(spline_parameters_array, percent, 'Spline', x_res,
                                                           location, seabed, outdir, n_tree=10, percent=10, n_bootstrap=500)
idw_rfstat, idw_rf_featimp = random_forest_bootstrap(idw_parameters_array, percent, 'IDW', x_res,
                                                           location, seabed, outdir, n_tree=10, percent=10, n_bootstrap=500)

bs_rfstatsumm = pd.concat((lin_rfstat,spl_rfstat,idw_rfstat), axis=0, ignore_index=True)
bs_rf_featimp = pd.concat((lin_rf_featimp,spl_rf_featimp,idw_rf_featimp), axis=0, ignore_index=True)
bs_rfstatsumm.to_csv(outdir+bsrfstat,index=False)
bs_rf_featimp.to_csv(outdir+bsrfimp,index=False)
print('RF BS done, time:',datetime.now())


# ANN with Scikit learn and Keras
# Define the names of the statsummary files.
nnstat = seabed + '_' + str(percent)+'%_random_nn_stats.csv'

def ANN(multi_array, samp_density, interpolator, resolution, location, seabed, outdir, plot=True, use_shap=True):
    data = multi_array.copy()

    yVar = data['residual']
    xVars = data[['distance', 'slope', 'roughness']]

    X_train, X_test, y_train, y_test = train_test_split(xVars, yVar, train_size=0.7, random_state=30)

    scaler = StandardScaler()
    X_train_scaled = scaler.fit_transform(X_train)
    X_test_scaled = scaler.transform(X_test)

    # Neural network
    model = Sequential()
    model.add(Dense(10, input_dim=3, activation='relu'))
    model.add(Dense(5, activation='relu'))
    model.add(Dense(1, activation='linear'))

    model.compile(loss='mean_squared_error', optimizer='adam', metrics=['mae'])

    # Train the model
    # nn_model = model.fit(X_train_scaled, y_train, validation_split=0.2, epochs=5)
    nn_model = model.fit(X_train_scaled, y_train, validation_split=0.2, epochs=1)
    # Predict the uncertainty
    y_pred_nn = model.predict(X_test_scaled)

    # Adjusted R-squared
    temp_data = pd.DataFrame(y_test.reset_index(drop=True))
    temp_pred = pd.DataFrame(y_pred_nn, columns=['estimate'])
    y_pred_test_nn = pd.concat([temp_data, temp_pred], axis=1)
    y_pred_test_nn_model = smf.ols('estimate ~ residual', y_pred_test_nn).fit()

    if use_shap:
        # Sample a fraction of the data for SHAP values
        fraction = 0.001  # Adjust the fraction as needed
        sampled_indices = random.sample(range(X_train.shape[0]), int(X_train.shape[0] * fraction))
        X_train_sampled = X_train.iloc[sampled_indices]

        # Explain the model predictions using SHAP values
        explainer = shap.KernelExplainer(model.predict, X_train_sampled)
        shap_values = explainer.shap_values(X_train_sampled)

        # Summarize the feature importance
        shap.summary_plot(shap_values, X_train_sampled)

    dfnnstat = pd.DataFrame(data={
        'area': [location],
        'seabed_type': [seabed],
        'interp_method': [interpolator],
        'ML_method': ['ANN'],
        'resolution': [resolution],
        'Sampling density': [samp_density],
        'variable': ['estimated residual'],
        'num_obs': [y_pred_test_nn_model.nobs],
        'rsqradj': [y_pred_test_nn_model.rsquared_adj],
        'f_pvalue': [y_pred_test_nn_model.f_pvalue],
        'rmse': np.sqrt(y_pred_test_nn_model.mse_resid),
        'intercept': [y_pred_test_nn_model.params[0]],
        'slope': [y_pred_test_nn_model.params[1]],
        'coeff_pvalue': [y_pred_test_nn_model.pvalues[0]]
    })

    if plot:
        plt.ioff()
        plt.figure(tight_layout=True)
        plt.scatter(y_test, y_pred_nn, label='Test Samples', s=3)
        plt.plot(y_test, y_pred_test_nn_model.predict(y_pred_test_nn), color='r', label='Regression Line')
        plt.xlabel('Residual (m)', fontsize=10)
        plt.ylabel('Estimated residual (m)', fontsize=10)
        plt.title(
            f"{interpolator.capitalize()} interpolator; ANN, {seabed.capitalize()} seabed, line spacing: {int(samp_density)}%\n"
            f"rsqradj: {round(y_pred_test_nn_model.rsquared_adj, 3)} "
            f"rmse: {round(y_pred_test_nn_model.mse_resid ** 0.5, 3)}",
            fontsize=10
        )
        plt.legend(fontsize=10,loc=1)
        plt.savefig(outdir + f"{seabed}_{location}_{interpolator}_ANN_EstRes_{int(samp_density)}%.png")
        plt.close()

    return dfnnstat, y_pred_test_nn_model, shap_values


lin_nnstat, lin_nn_model, lin_nnsharp = ANN(lin_parameters_array, percent, 'Linear', x_res,
                                                           location, seabed, outdir, plot=False, use_shap=True)
spl_nnstat, spl_nn_model = ANN(spline_parameters_array, percent, 'Spline', x_res,
                                                           location, seabed, outdir, plot=True, use_shap=True)
idw_nnstat, idw_nn_model = ANN(idw_parameters_array, percent, 'IDW', x_res,
                                                           location, seabed, outdir, plot=True, use_shap=True)

nnstatsumm = pd.DataFrame()
nnstatsumm = pd.concat([nnstatsumm, lin_nnstat,spl_nnstat,idw_nnstat], axis=0)
nnstatsumm.to_csv(outdir+nnstat,index=False)

print('ANN completed, time:',datetime.now())


