import numpy as np
import pandas as pd

# Create a function for finding percentile of an array
def find_percentile(array, percentile, ndv):
    # Handle no-data values
    if 0 in array:
        array[array == 0] = np.nan  # set the ndv to nan so as to display the ndv as white color
    else:
        array[array == ndv] = np.nan  # set the ndv to nan so as to display the ndv as white color

    # take the absolute value of the array
    array = abs(array)

    # Flatten and reshape the array
    array = array.flatten().reshape(-1, 1)

    # Put data into a DataFrame
    # df = pd.DataFrame(array, columns=['value']).dropna().sort_values(by='value').reset_index(drop=True)
    df = pd.DataFrame(array, columns=['value']).dropna().sort_values(by='value')

    # Calculate the percentile value
    percentile_value = df['value'].quantile(percentile / 100)

    # Filter the DataFrame based on the percentile
    sliced_df = df[df <= percentile_value].dropna()
    # idx = df.loc[df['value'] >= percentile_value].index
    # sliced_df = df.iloc[0:idx[0]] if not idx.empty else df

    return sliced_df.values