import numpy as np


def calculate_raster_roughness(array, window_size):
    half_window = window_size // 2
    roughness_array = np.zeros_like(array)

    for i in range(half_window, array.shape[0] - half_window):
        for j in range(half_window, array.shape[1] - half_window):
            window = array[i - half_window:i + half_window + 1, j - half_window:j + half_window + 1]
            roughness_array[i, j] = np.max(window) - np.min(window)

    return roughness_array
