"""
Created on Mon Jul 10 19:42:32 2023

@author: Elias Adediran
"""

import numpy as np
import random

random.seed(44)

def sample_raster_by_percent(raster_array, sample_percentage, ndv):
    # Determine the number of pixels to sample based on the percentage
    num_pixels = np.prod(raster_array.shape)
    num_sample_pixels = int(num_pixels * (sample_percentage / 100))

    # Generate random pixel indices to sample
    random_indices = np.random.choice(num_pixels, size=num_sample_pixels, replace=False)

    # Create a mask for the sampled pixels
    sample_mask = np.zeros_like(raster_array, dtype=bool)
    sample_mask.flat[random_indices] = True

    # Create a new array with NaN values for unselected pixels
    train_sample = np.where(sample_mask, raster_array, ndv)

    # Create the opposite array with NaN values for the selected pixels
    test_sample = np.where(sample_mask, ndv, raster_array)

    # Return the sampled array and its opposite
    return train_sample, test_sample

